#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tk.h>
#include "photo.hh"
#include "Image.hh"
#include "morfo.hh"
#include "couleur.hh"
#include "tpmorpho2.hh"

/* stockage des infos d'image */

Tk_PhotoImageBlock *blockPtr;

static int TAB[9][9];

template <class T> struct infoimage{
  Image<int> img;
  Tk_PhotoHandle handle;
};

/* Conversion Format Tk --> Inti */

Image<int> tkimage2Inti(Tk_PhotoImageBlock *tkim,int composante){
       int i,j,n;
       int *pixrim;
       unsigned char *pixtk;
       int tw=tkim->width;
       int th=tkim->height;
       Image<int> p(tw,th);

       pixrim=p.PI();
       for (j=0;j<tkim->height;j++) {
	 pixtk=tkim->pixelPtr + tkim->pitch*j;
          for (i=0;i<tkim->width;i++) {
	    if (composante > 0) {//Cas d'une composante (image en niveau de gris)
	      n = (int)(*(pixtk+tkim->offset[composante-1]));
	    } else {//Cas d'une image couleur : entier 24 bits
	      n = (int)(*(pixtk+tkim->offset[0])) 
		+ ((int)(*(pixtk+tkim->offset[1])))*256
		+ ((int)(*(pixtk+tkim->offset[2])))*65536;
	    }
	    *pixrim = n;
	    pixtk+=tkim->pixelSize;pixrim++;
          }
       }
       return p;
}

/* Conversions Format Inti --> Tk */

Tk_PhotoImageBlock *Inti2tkimage_gray(Image<int>& pp,Tk_PhotoImageBlock *tkim) {
       unsigned char *tempotk;
       int *tempoplan;
       int i;
       if (tkim == NULL) {
              tkim = (Tk_PhotoImageBlock *)malloc(sizeof(Tk_PhotoImageBlock));
	      tkim->pixelPtr = NULL;
       }

       tkim->width=pp.PW();
       tkim->height=pp.PL();
       tkim->pixelSize=3;
       tkim->pitch=tkim->width*tkim->pixelSize;
       tkim->offset[0]=0;
       tkim->offset[1]=1;
       tkim->offset[2]=2;

       if (tkim->pixelPtr == NULL) {
	 tempotk= tkim->pixelPtr=(unsigned char *)malloc(tkim->pixelSize*tkim->width*tkim->height*sizeof(unsigned char));
       } else {
	 tempotk= tkim->pixelPtr=(unsigned char *)realloc(tkim->pixelPtr,tkim->pixelSize*tkim->width*tkim->height*sizeof(unsigned char));
       }
       tempoplan=pp.PI();
       for (i=0;i<tkim->width*tkim->height;i++) {
	 *tempotk = *(tempotk+tkim->offset[1]) = *(tempotk+tkim->offset[2]) = (unsigned char)(*tempoplan);
	 tempoplan++;
	 tempotk+=tkim->pixelSize;
       }
       return tkim;
}

Tk_PhotoImageBlock *Inti2tkimage_color(Image<int>& pp,Tk_PhotoImageBlock *tkim) {
       unsigned char *tempotk;
       int *tempoplan;
       int i;
       if (tkim == NULL) {
              tkim = (Tk_PhotoImageBlock *)malloc(sizeof(Tk_PhotoImageBlock));
	      tkim->pixelPtr = NULL;
       }

       tkim->width=pp.PW();
       tkim->height=pp.PL();
       tkim->pixelSize=3;
       tkim->pitch=tkim->width*tkim->pixelSize;
       tkim->offset[0]=0;
       tkim->offset[1]=1;
       tkim->offset[2]=2;

       if (tkim->pixelPtr == NULL) {
	 tempotk= tkim->pixelPtr=(unsigned char *)malloc(tkim->pixelSize*tkim->width*tkim->height*sizeof(unsigned char));
       } else {
	 tempotk= tkim->pixelPtr=(unsigned char *)realloc(tkim->pixelPtr,tkim->pixelSize*tkim->width*tkim->height*sizeof(unsigned char));
       }
       tempoplan=pp.PI();
       for (i=0;i<tkim->width*tkim->height;i++) {
	 *(tempotk+tkim->offset[0]) = (*tempoplan)%256; 
	 *(tempotk+tkim->offset[1]) = ((*tempoplan)>>8)%256;
	 *(tempotk+tkim->offset[2]) = ((*tempoplan)>>16)%256;
	 tempoplan++;
	 tempotk+=tkim->pixelSize;
       }
       return tkim;
}


void freetkim(Tk_PhotoImageBlock *tkim) {
       free(tkim->pixelPtr);
       free(tkim);
}


int Inti_cmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
       infoimage<int>* cdata;
       cdata  = (infoimage<int>*) clientData;
       
       float x;
       int a,b,c;
       int chg;
       int mesure_int1,mesure_int2;
       float mesure_float;
       char *numb;
       
       if (argc > 2) a = atoi(argv[2]);
       if (argc > 3) b = atoi(argv[3]);  
       if (argc > 4) c = atoi(argv[4]); 
       //printf("%s\n",argv[1]);
       if (strncmp(argv[1],"change_bord",10) == 0) {
       ChangeBord(a);chg=0;}
       else
       if (strcmp(argv[1],"setvaluemasque") == 0) {
	 TAB[a+4][b+4]=c;chg=0;} 
       else
       if (strcmp(argv[1],"save") == 0) {cdata[a].img.Imagetopgm(argv[3]);chg=0;}
       else
       if  (strcmp(argv[1],"defaire") == 0) {
	 cdata[a].img.DepileArriere();chg=1;}
       else 
       if  (strcmp(argv[1],"refaire") == 0) {
	 cdata[a].img.DepileAvant();chg=1;}
       else
       if (strcmp(argv[1],"copy") == 0) {cdata[a].img.Empile(argv[1]);cdata[a].img = cdata[b].img;chg=1;}  
       else
       if (strcmp(argv[1],"et") == 0) {cdata[a].img.Empile(argv[1]);cdata[a].img = cdata[a].img & cdata[b].img;chg=1;}
       else
       if (strcmp(argv[1],"ou") == 0) {cdata[a].img.Empile(argv[1]);cdata[a].img = cdata[a].img | cdata[b].img;chg=1;}
       else
       if (strcmp(argv[1],"xor") == 0) {cdata[a].img.Empile(argv[1]);cdata[a].img = cdata[a].img ^ cdata[b].img;chg=1;}
       else
       if (strcmp(argv[1],"diff") == 0) {cdata[a].img.Empile(argv[1]);cdata[a].img = cdata[a].img.Image_diff(cdata[b].img);chg=1;}
       else
       if (strcmp(argv[1],"non") == 0) {cdata[a].img.Empile(argv[1]);cdata[a].img = !cdata[a].img;chg=1;}
       else
	 if (strcmp(argv[1],"morpho") == 0) {cdata[a].img.Empile(argv[1]);Morphobase(cdata[a].img,argv[3],TAB);chg=1;}
       else 
       if (strcmp(argv[1],"seuil") == 0) {
	 if (cdata[a].img.DerniereOperation() && (strcmp(cdata[a].img.DerniereOperation(),"seuil")==0)) cdata[a].img.DepileArriere();
	 cdata[a].img.Empile(argv[1]);
	 cdata[a].img = cdata[a].img.Image_seuil(b);chg=1;}
       else  
       if (strcmp(argv[1],"reconstruit") == 0) {cdata[a].img.Empile(argv[1]);Reconstruit(cdata[a].img,cdata[b].img,c);chg=1;}
       else 
       if (strcmp(argv[1],"eroult") == 0) {cdata[a].img.Empile(argv[1]);Ero_ult(cdata[a].img,b);chg=1;}
       else
       if (strcmp(argv[1],"maxpropag") == 0) {cdata[a].img.Empile(argv[1]);MaxPropag(cdata[a].img,b);chg=1;}
       else
       if (strcmp(argv[1],"maxloc") == 0) {cdata[a].img.Empile(argv[1]);Maxlocaux(cdata[a].img,b);chg=1;}
       else
       if (strcmp(argv[1],"maxreg") == 0) {cdata[a].img.Empile(argv[1]);Max_regionaux(cdata[a].img,b);chg=1;} 
       else
       if (strcmp(argv[1],"fctdist") == 0) {cdata[a].img.Empile(argv[1]);FctDistance(cdata[a].img,argv[3]);chg=1;}  
       else
       if (strcmp(argv[1],"fde") == 0) {cdata[a].img.Empile(argv[1]);Fct_distance_euclidienne(cdata[a].img);chg=1;}  
       else
       if (strcmp(argv[1],"lpe") == 0) {
         cdata[a].img.Empile(argv[1]);LPE(cdata[a].img,b);chg=1;}
       else
       if (strcmp(argv[1],"lpe_mark") == 0) {
	 cdata[a].img.Empile(argv[1]);LPE_Markers(cdata[a].img,cdata[b].img,c);chg=1;}
       else 
       if (strcmp(argv[1],"decomp_RGB") == 0) {
	 for (a=1;a<=3;a++) cdata[a].img.Empile(argv[1]);
	 DecomposeRGB(cdata[0].img,cdata[1].img,cdata[2].img,cdata[3].img);chg=3;}
       else
       if (strcmp(argv[1],"recomp_RGB") == 0) {
	 RecomposeRGB(cdata[0].img,cdata[1].img,cdata[2].img,cdata[3].img);chg=2;}
       else 
       if (strcmp(argv[1],"decomp_HSV") == 0) {
	 for (a=1;a<=3;a++) cdata[a].img.Empile(argv[1]);
	 DecomposeHSV(cdata[0].img,cdata[1].img,cdata[2].img,cdata[3].img);chg=3;}
       else 
       if (strcmp(argv[1],"decomp_YUV") == 0) {
	 for (a=1;a<=3;a++) cdata[a].img.Empile(argv[1]);
	 DecomposeYUV(cdata[0].img,cdata[1].img,cdata[2].img,cdata[3].img);chg=3;}
       else 
       if (strcmp(argv[1],"tpColor") == 0) {
	 for (a=1;a<=3;a++) cdata[a].img.Empile(argv[1]);
	 TPCouleur(cdata[1].img,cdata[2].img,cdata[3].img,a,b);chg=3;}
       else
       if (strcmp(argv[1],"tpGray") == 0) {
	 cdata[a].img.Empile(argv[1]);TPGris(cdata[a].img,b,c);chg=1;}
       else
	 if (strcmp(argv[1],"tpTest") == 0) {
	   cdata[a].img.Empile(argv[1]);
	   TPTest(cdata[a].img,a,b,&mesure_int1,&mesure_int2,&mesure_float);
	   numb = (char*)malloc(25*sizeof(char));
	   sprintf(numb,"%d",mesure_int1);
	   Tcl_AppendElement(interp,numb);
	   sprintf(numb,"%d",mesure_int2);
	   Tcl_AppendElement(interp,numb);
	   sprintf(numb,"%f",mesure_float);
	   Tcl_AppendElement(interp,numb);
	   free(numb);
	   chg=1;}
       if (chg == 1) {//Une seule image en niveau de gris change
	blockPtr=Inti2tkimage_gray(cdata[a].img,blockPtr);
	Tk_PhotoPutBlock(cdata[a].handle, blockPtr, 0, 0, blockPtr->width, blockPtr->height);} else if (chg == 2) {//Seule l'image couleur change
	 blockPtr=Inti2tkimage_color(cdata[0].img,blockPtr);
	 Tk_PhotoPutBlock(cdata[0].handle, blockPtr, 0, 0, blockPtr->width, blockPtr->height);} else if (chg == 3) {//Les 3 composantes (niveau de gris) changent
	 for (a=1;a<=3;a++) {
	   blockPtr=Inti2tkimage_gray(cdata[a].img,blockPtr);
	   Tk_PhotoPutBlock(cdata[a].handle, blockPtr, 0, 0, blockPtr->width, blockPtr->height);}
       }
       return TCL_OK;       
}

int img_new(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
       infoimage<int> *cdata;
       Tk_PhotoImageBlock blockPtr;
       int x = atoi(argv[2]);
       cdata = (infoimage<int>*) clientData;
     if (argc != 3) {
                Tcl_SetResult(interp,"Usage: Imgnew <image> <numero>",TCL_VOLATILE);
		return TCL_ERROR;
	}
   cdata[x].handle=Tk_FindPhoto(interp,argv[1]);
   Tk_PhotoGetImage(cdata[x].handle, &blockPtr);
   cdata[x].img=tkimage2Inti(&blockPtr,x);
 return TCL_OK;
}


/* creation d'une image de type Inti */
/* Intinew <nomimage> <nomcommanderet> */

void init_retcc() {
blockPtr = NULL;
}

int Inti_new(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
       infoimage<int> *cdata;

       if (argc != 3) {
         Tcl_SetResult(interp,"Usage: Intinew <nomcommande> <nb_images>",TCL_VOLATILE);
	 return TCL_ERROR;
       }
       int nbimages = atoi(argv[2]);
       cdata = new infoimage<int>[nbimages];
       Tcl_CreateCommand(interp, "Imgnew", img_new, (ClientData)cdata,(Tcl_CmdDeleteProc *)NULL);
       Tcl_CreateCommand(interp, argv[1], Inti_cmd, (ClientData)cdata,(Tcl_CmdDeleteProc *)NULL);
       return TCL_OK;
}


