#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "Image.hh"
#include "morfo.hh"
#include "tpmorpho2.hh"


// Exemple de traitement en niveau de gris, agit sur une 
// seule composante. Cet exemple dtecte les points dont 
// la valeur diffre de plus de "seuil" pour au moins un
// point de leur voisinage carr de rayon "parametre" 

void TPGris(Image<int>& p,int seuil,int parametre) {

  printf("Traitement en niveau de gris\n");
  printf("Avec le seuil = %d\n",seuil);
  printf("Et le parametre = %d\n",parametre);
  
  int i,j,k,l,index;
  int h=p.PL();
  int w=p.PW();
  int* PIX=p.PI();
  Image<int> q(p);
  int* QPIX=q.PI();
  
  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      PIX[index] = 0;
      for (k=-parametre;k<=parametre;k++) 
	for (l=-parametre;l<=parametre;l++) 
	  if (abs(QPIX[index]-q.X(i+k,j+l)) > seuil) 
	    PIX[index] = 255;
      index++;
    }
}

// Exemple de traitement couleur, agit sur les 3 composantes
// cet exemple slectionne la composante dominante (ArgMax {R,G,B})

void TPCouleur(Image<int>& p_c1,Image<int>& p_c2,Image<int>& p_c3,int seuil,int parametre) {

  int i,j,index;
  int h=p_c1.PL();
  int w=p_c1.PW();
  int* C1=p_c1.PI();
  int* C2=p_c2.PI();
  int* C3=p_c3.PI();
  
  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      if ((C1[index] > C2[index])&&(C1[index] > C3[index]))
	C1[index] = 255; else C1[index] = 0;
      if ((C2[index] > C1[index])&&(C2[index] > C3[index]))
	C2[index] = 255; else C2[index] = 0;
      if ((C3[index] > C1[index])&&(C3[index] > C2[index]))
	C3[index] = 255; else C3[index] = 0;
      index++;
    }
}

// Exemple de traitement  utiliser dans les scripts
// Celui-ci renvoie 2 entiers et un float

void TPTest(Image<int>& p,int seuil,int parametre,int *mesure1,int *mesure2,float *mesure3) {

  *mesure1 = seuil;
  *mesure2 = parametre;
  *mesure3 = sqrt(seuil);
}
